



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[转帖]awk 入门</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[转帖]awk 入门</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-16 15:25:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><code>awk</code>其实不仅仅是工具软件，还是一种编程语言。不过，本文只介绍它的命令行用法，对于大多数场合，应该足够用了。</p>
<p>http://www.ruanyifeng.com/blog/2018/11/awk.html</p>
<h2>一、基本用法</h2>
<p><code>awk</code>的基本用法就是下面的形式。</p>
<blockquote><pre class="prettyprint linenums"><code>
# 格式
$ awk 动作 文件名

# 示例
$ awk '{print $0}' demo.txt
</code></pre></blockquote>
<p>上面示例中，<code>demo.txt</code>是<code>awk</code>所要处理的文本文件。前面单引号内部有一个大括号，里面就是每一行的处理动作<code>print $0</code>。其中，<code>print</code>是打印命令，<code>$0</code>代表当前行，因此上面命令的执行结果，就是把每一行原样打印出来。</p>
<p>下面，我们先用标准输入（stdin）演示上面这个例子。</p>
<blockquote><pre class="prettyprint linenums"><code>
$ echo 'this is a test' | awk '{print $0}'
this is a test
</code></pre></blockquote>
<p>上面代码中，<code>print $0</code>就是把标准输入<code>this is a test</code>，重新打印了一遍。</p>
<p><code>awk</code>会根据空格和制表符，将每一行分成若干字段，依次用<code>$1</code>、<code>$2</code>、<code>$3</code>代表第一个字段、第二个字段、第三个字段等等。</p>
<blockquote><pre class="prettyprint linenums"><code>
$ echo 'this is a test' | awk '{print $3}'
a
</code></pre></blockquote>
<p>上面代码中，<code>$3</code>代表<code>this is a test</code>的第三个字段<code>a</code>。</p>
<p>下面，为了便于举例，我们把<code>/etc/passwd</code>文件保存成<code>demo.txt</code>。</p>
<blockquote><pre class="prettyprint linenums"><code>a
root:x:0:0:root:/root:/usr/bin/zsh
daemon:x:1:1:daemon:/usr/sbin:/usr/sbin/nologin
bin:x:2:2:bin:/bin:/usr/sbin/nologin
sys:x:3:3:sys:/dev:/usr/sbin/nologin
sync:x:4:65534:sync:/bin:/bin/sync
</code></pre></blockquote>
<p>这个文件的字段分隔符是冒号（<code>:</code>），所以要用<code>-F</code>参数指定分隔符为冒号。然后，才能提取到它的第一个字段。</p>
<blockquote><pre class="prettyprint linenums"><code>
$ awk -F ':' '{ print $1 }' demo.txt
root
daemon
bin
sys
sync
</code></pre></blockquote>
<h2>二、变量</h2>
<p>除了<code>$ + 数字</code>表示某个字段，<code>awk</code>还提供其他一些变量。</p>
<p>变量<code>NF</code>表示当前行有多少个字段，因此<code>$NF</code>就代表最后一个字段。</p>
<blockquote><pre class="prettyprint linenums"><code>
$ echo 'this is a test' | awk '{print $NF}'
test
</code></pre></blockquote>
<p><code>$(NF-1)</code>代表倒数第二个字段。</p>
<blockquote><pre class="prettyprint linenums"><code>
$ awk -F ':' '{print $1, $(NF-1)}' demo.txt
root /root
daemon /usr/sbin
bin /bin
sys /dev
sync /bin
</code></pre></blockquote>
<p>上面代码中，<code>print</code>命令里面的逗号，表示输出的时候，两个部分之间使用空格分隔。</p>
<p>变量<code>NR</code>表示当前处理的是第几行。</p>
<blockquote><pre class="prettyprint linenums"><code>
$ awk -F ':' '{print NR ") " $1}' demo.txt
1) root
2) daemon
3) bin
4) sys
5) sync
</code></pre></blockquote>
<p>上面代码中，<code>print</code>命令里面，如果原样输出字符，要放在双引号里面。</p>
<p><code>awk</code>的其他内置变量如下。</p>
<blockquote><ul><li><code>FILENAME</code>：当前文件名</li>
<li><code>FS</code>：字段分隔符，默认是空格和制表符。</li>
<li><code>RS</code>：行分隔符，用于分割每一行，默认是换行符。</li>
<li><code>OFS</code>：输出字段的分隔符，用于打印时分隔字段，默认为空格。</li>
<li><code>ORS</code>：输出记录的分隔符，用于打印时分隔记录，默认为换行符。</li>
<li><code>OFMT</code>：数字输出的格式，默认为<code>％.6g</code>。</li></ul></blockquote>
<h2>三、函数</h2>
<p><code>awk</code>还提供了一些内置函数，方便对原始数据的处理。</p>
<p>函数<code>toupper()</code>用于将字符转为大写。</p>
<blockquote><pre class="prettyprint linenums"><code>
$ awk -F ':' '{ print toupper($1) }' demo.txt
ROOT
DAEMON
BIN
SYS
SYNC
</code></pre></blockquote>
<p>上面代码中，第一个字段输出时都变成了大写。</p>
<p>其他常用函数如下。</p>
<blockquote><ul><li><code>tolower()</code>：字符转为小写。</li>
<li><code>length()</code>：返回字符串长度。</li>
<li><code>substr()</code>：返回子字符串。</li>
<li><code>sin()</code>：正弦。</li>
<li><code>cos()</code>：余弦。</li>
<li><code>sqrt()</code>：平方根。</li>
<li><code>rand()</code>：随机数。</li></ul></blockquote>
<p><code>awk</code>内置函数的完整列表，可以查看<a href="https://www.gnu.org/software/gawk/manual/html_node/Built_002din.html#Built_002din" rel="external nofollow noreferrer">手册</a>。</p>
<h2>四、条件</h2>
<p><code>awk</code>允许指定输出条件，只输出符合条件的行。</p>
<p>输出条件要写在动作的前面。</p>
<blockquote><pre class="prettyprint linenums"><code>
$ awk '条件 动作' 文件名
</code></pre></blockquote>
<p>请看下面的例子。</p>
<blockquote><pre class="prettyprint linenums"><code>
$ awk -F ':' '/usr/ {print $1}' demo.txt
root
daemon
bin
sys
</code></pre></blockquote>
<p>上面代码中，<code>print</code>命令前面是一个正则表达式，只输出包含<code>usr</code>的行。</p>
<p>下面的例子只输出奇数行，以及输出第三行以后的行。</p>
<blockquote><pre class="prettyprint linenums"><code>
# 输出奇数行
$ awk -F ':' 'NR % 2 == 1 {print $1}' demo.txt
root
bin
sync

# 输出第三行以后的行
$ awk -F ':' 'NR &gt;3 {print $1}' demo.txt
sys
sync
</code></pre></blockquote>
<p>下面的例子输出第一个字段等于指定值的行。</p>
<blockquote><pre class="prettyprint linenums"><code>
$ awk -F ':' '$1 == "root" {print $1}' demo.txt
root

$ awk -F ':' '$1 == "root" || $1 == "bin" {print $1}' demo.txt
root
bin
</code></pre></blockquote>
<h2>五、if 语句</h2>
<p><code>awk</code>提供了<code>if</code>结构，用于编写复杂的条件。</p>
<blockquote><pre class="prettyprint linenums"><code>
$ awk -F ':' '{if ($1 &gt; "m") print $1}' demo.txt
root
sys
sync
</code></pre></blockquote>
<p>上面代码输出第一个字段的第一个字符大于<code>m</code>的行。</p>
<p><code>if</code>结构还可以指定<code>else</code>部分。</p>
<blockquote><pre class="prettyprint linenums"><code>
$ awk -F ':' '{if ($1 &gt; "m") print $1; else print "---"}' demo.txt
root
---
---
sys
sync
</code></pre></blockquote>
<h2>六、参考链接</h2>
<ul><li><a href="https://gregable.com/2010/09/why-you-should-know-just-little-awk.html" rel="external nofollow noreferrer">An Awk tutorial by Example</a>, Greg Grothaus</li>
<li><a href="https://likegeeks.com/awk-command/" rel="external nofollow noreferrer">30 Examples for Awk Command in Text Processing</a>, Mokhtar Ebrahim</li></ul>
<p>（完）</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49g3xg4q.html">ios cocopods 安装使用及高级教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93nvpnq.html">Linux下如何修改Apache根目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv7ekyq.html">jquery操作select&lpar;取值，设置选中）</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q74nneq.html">Scrapy and Selenium</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1kmnr9.html">mac 如何进入&sol;usr&sol;sbin目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x3vdg9.html">ComboBoxEdit数据绑定</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e13pom9.html">centos7安装mplayer以及出现的各种问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxngr7z8.html">RSA 加解密 签名 示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk2pre8.html">bzoj1417&colon; Pku3156 Interconnect</a>
		</li>
						<li><a href="https://www.batexi.com/a/950p4nm8.html">zf-关于荆州图片链接和弹出页面问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1047dq.html">JqueryMobile基础之创建页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j6edl8.html">怎么选择公司？？？MVC加jquery-easyui 后端工程师</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k33m29.html">Daily Codeforces 计划 训练时录</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jrlnl8.html">Saltstack自动化操作记录（2）-配置使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e40roj9.html">tensorflow中使用指定的GPU及GPU显存 CUDA&lowbar;VISIBLE&lowbar;DEVICES</a>
		</li>
						<li><a href="https://www.batexi.com/a/q250ejvq.html">SQL Server常见的操作符</a>
		</li>
						<li><a href="https://www.batexi.com/a/960ynzn9.html">GOF提出的23种设计模式是哪些 设计模式有创建形、行为形、结构形三种类别 常用的Javascript中常用设计模式的其中17种 详解设计模式六大原则</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwgk1z9.html">ceph集群性能测试结果</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwop0z8.html">软工网络15团队作业4&mdash;&mdash;Alpha阶段敏捷冲刺5&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw14ek8.html">SQLServer&amp;&num;160&semi;学习笔记之超详细基础SQL语句&amp;&num;160&semi;Part&amp;&num;160&semi;7</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93pgn5w8.html">intellIJ IDEA配置maven相关问题记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjrw1r8.html">c&num;指针和寻址运算</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e0g4e9.html">c&num; ajax从后台获取数据list数组 &dollar;&period;each再显示数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4p3ke0q.html">Apache和Nginx比较</a>
			</li>
						<li><a href="https://www.batexi.com/a/902ky13q.html">python的变量的命名规则以及定义</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1pv7k9.html">python-我的第一门编程语言</a>
			</li>
						<li><a href="https://www.batexi.com/a/963zd1y9.html">VRRP&plus;tunnel&plus;IP SLA&plus;Track实现冗余切换</a>
			</li>
						<li><a href="https://www.batexi.com/a/8korklrq.html">vue&period;js和vue-router和vuex快速上手知识</a>
			</li>
						<li><a href="https://www.batexi.com/a/902kkrjq.html">Babylon&period;js官方性能优化文档中文翻译</a>
			</li>
						<li><a href="https://www.batexi.com/a/902kkxoq.html">【CodeForces-1041C】Coffee Break（二分解决关于set&comma;pair&comma;upper&lowbar;bound用法）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
